<?xml version="1.0" encoding="UTF-8"?>
<xs:schema xmlns:xs="http://www.w3.org/2001/XMLSchema" elementFormDefault="qualified">

    <xs:element name="GazelleCrossValidationReport">
        <xs:complexType>
            <xs:sequence>
                <xs:element name="ReportSummary" type="Summary"/>
                <xs:element name="Notifications">
                    <xs:complexType>
                        <xs:sequence maxOccurs="unbounded">
                            <xs:choice>
                                <xs:element name="Error" type="Error"/>
                                <xs:element name="Warning" type="Warning"/>
                                <xs:element name="Info" type="Info"/>
                                <xs:element name="Report" type="Report"/>
                                <xs:element name="Aborted" type="Aborted"/>
                            </xs:choice>
                        </xs:sequence>
                    </xs:complexType>
                </xs:element>
                <xs:element maxOccurs="unbounded" minOccurs="0" name="XSDValidation"
                    type="XSDValidation"/>
            </xs:sequence>
        </xs:complexType>
    </xs:element>
    <xs:complexType name="GazelleCrossValidatorDescription">
        <xs:sequence>
            <xs:element name="CalledValidator" type="CrossValidatorDescription"/>
            <xs:element maxOccurs="unbounded" minOccurs="0" name="LinkedValidator"
                type="CrossValidatorDescription"/>
        </xs:sequence>
        <xs:attribute name="engineVersion"/>
    </xs:complexType>
    <xs:complexType name="Notification">
        <xs:sequence>
            <xs:element name="Test" type="xs:string">
                <xs:annotation>
                    <xs:documentation>The unique identifier of the corresponding rule, is enough to create the link to the documentation</xs:documentation>
                </xs:annotation>
            </xs:element>
            <xs:element name="Description" type="xs:string">
                <xs:annotation>
                    <xs:documentation>from the rule description</xs:documentation>
                </xs:annotation>
            </xs:element>
            <xs:element maxOccurs="unbounded" name="ProcessedInput" type="xs:string" minOccurs="0">
                <xs:annotation>
                    <xs:documentation>Where the error was located in the message (used for filtering results)
If this elements it not present, it implies that all the declared inputs have been processed within this rule</xs:documentation>
                </xs:annotation>
            </xs:element>
            <xs:element maxOccurs="unbounded" minOccurs="0" name="Assertion" type="assertion">
                <xs:annotation>
                    <xs:documentation>List the assertions covered by the executed rule</xs:documentation>
                </xs:annotation>
            </xs:element>
            <xs:element name="Expression" type="xs:string"/>
        </xs:sequence>
    </xs:complexType>
    <xs:complexType name="Locator">
        <xs:attribute name="appliesOn" type="xs:string">
            <xs:annotation>
                <xs:documentation>for filtering, in which of the messages/documents the error is</xs:documentation>
            </xs:annotation>
        </xs:attribute>
        <xs:attribute name="path" type="xs:string" use="optional">
            <xs:annotation>
                <xs:documentation>where the rule was applied</xs:documentation>
            </xs:annotation>
        </xs:attribute>
    </xs:complexType>
    <xs:complexType name="assertion">
        <xs:attribute name="idScheme" type="xs:string" use="required"/>
        <xs:attribute name="assertionId" type="xs:string" use="required"/>
    </xs:complexType>
    <xs:complexType name="Summary">
        <xs:sequence>
            <xs:element name="GazelleCrossValidator" type="GazelleCrossValidatorDescription"/>
            <xs:element name="ValidationDate" type="xs:dateTime"/>
            <xs:element name="ValidationResult">
                <xs:simpleType>
                    <xs:restriction base="xs:string">
                        <xs:enumeration value="PASSED"/>
                        <xs:enumeration value="FAILED"/>
                        <xs:enumeration value="ABORTED"/>
                    </xs:restriction>
                </xs:simpleType>
            </xs:element>
            <xs:element name="ValidationCounters" type="Counters"/>
        </xs:sequence>
    </xs:complexType>
    <xs:complexType name="Counters">
        <xs:sequence>
            <xs:element name="nrOfChecks" type="xs:int"/>
            <xs:element name="NrOfValidationErrors" type="xs:int"/>
            <xs:element name="NrOfValidationWarnings" type="xs:int"/>
            <xs:element name="NrOfValidationInfos" type="xs:int"/>
            <xs:element name="NrOfValidationReports" type="xs:int"/>
            <xs:element name="NrOfValidationUnknown" type="xs:int"/>
            <xs:element name="NrOfValidationAborted" type="xs:int"/>
        </xs:sequence>
    </xs:complexType>
    <xs:complexType name="CrossValidatorDescription">
        <xs:attribute name="name" type="xs:string" use="required"/>
        <xs:attribute name="version" type="xs:string" use="required"/>
        <xs:attribute name="affinityDomain" type="xs:string" use="required"/>
    </xs:complexType>
    <xs:complexType name="Error">
        <xs:complexContent>
            <xs:extension base="Notification"/>
        </xs:complexContent>
    </xs:complexType>
    <xs:complexType name="Report">
        <xs:complexContent>
            <xs:extension base="Notification"/>
        </xs:complexContent>
    </xs:complexType>
    <xs:complexType name="Warning">
        <xs:complexContent>
            <xs:extension base="Notification"/>
        </xs:complexContent>
    </xs:complexType>
    <xs:complexType name="Info">
        <xs:complexContent>
            <xs:extension base="Notification"/>
        </xs:complexContent>
    </xs:complexType>
    <xs:complexType name="XSDValidation">
        <xs:sequence>
            <xs:element maxOccurs="unbounded" minOccurs="0" name="Detail" type="XSDDetail"/>
            <xs:element name="Result">
                <xs:simpleType>
                    <xs:restriction base="xs:string">
                        <xs:enumeration value="PASSED"/>
                        <xs:enumeration value="FAILED"/>
                        <xs:enumeration value="ABORTED"/>
                    </xs:restriction>
                </xs:simpleType>
            </xs:element>
        </xs:sequence>
        <xs:attribute name="keyword" type="xs:string" use="required"/>
        <xs:attribute name="xsdLocation" type="xs:string" use="required"/>
        <xs:attribute name="file" type="xs:string"/>
        <xs:attribute default="0" name="errors" type="xs:int"/>
        <xs:attribute default="0" name="warning" type="xs:int"/>
    </xs:complexType>
    <xs:complexType name="XSDDetail">
        <xs:sequence>
            <xs:element name="Message" type="xs:string"/>
        </xs:sequence>
        <xs:attribute name="severity"/>
        <xs:attribute name="lineNumber"/>
        <xs:attribute name="columnNumber"/>
    </xs:complexType>
    <xs:complexType name="Aborted">
        <xs:complexContent>
            <xs:extension base="Notification"/>
        </xs:complexContent>
    </xs:complexType>
</xs:schema>
